<?
	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		parse_str($argv[2], $param);
	}
	
	$PATH="../";
	include_once($PATH."include/include.php");
	include_once($PATH."include/admin.php");															/* Page Admin		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");		/* Entete HTML		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");	/* Entete HTML		*/
	
	$dbprof=new ps_db;
	$dbfeng=new ps_db;
	$dbfeng->dbname("fengoffice");
	

	set_time_limit(60000);
	
//==FUNCTION===========================================================================================================================================
	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}
	
	function AfficheContinue($label) {
		echo $label;
	 }

	// Création d'un utilisateur Fengoffice
	define ("TABLE_PREFIX", "fo_");
	function creerUserFengoffice ($idSociete, $uid, $role, $nom, $prenom, $mail)
	{
		// Récup variable globale de l'objet de base de données
		global $dbfeng;
		
		// Protection des champs à inserer par des addSlashes
		$idSociete = addSlashes ($idSociete);
		$uid = addSlashes ($uid);
		$nom = addSlashes ($nom);
		$prenom = addSlashes ($prenom);
		$mail = addSlashes ($mail);
		
		// Tester si l'utilisateur existe
		$dbfeng->query("SELECT object_id FROM " . TABLE_PREFIX . "contacts WHERE username='$uid' AND is_company='0'");
		// Si il n'existe pas, on ajouter
		if(! $dbfeng->next_record() )
		{
			// Crée l'objet correspondant à l'utilisateur et récuperer son id
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "objects VALUES (null, 15, '$nom $prenom', now(), 2, now(), 2, '0000-00-00 00:00:00', 0, '0000-00-00 00:00:00', 0)");
			if ($dbfeng->errno!=0) print "!!!#1:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$ob_id = mysql_insert_id();

			// Crée le groupe de permission de cet utilisateur et récupérer son id
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "permission_groups VALUES (null, 'User $ob_id Personal', '$ob_id', 0, 0, 0, 'permission_groups')");
			if ($dbfeng->errno!=0) print "!!!#2:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$pg_id=mysql_insert_id();

			// Permissions systême : en fonction du rôle
			$permContact=12;
			switch ($role)
			{
				case 'guest':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)");
				$permContact=12;
				break;

				case 'guestcustomer':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0)");
				$permContact=11;
				break;

				case 'externalcollaborator':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1)");
				$permContact=7;
				break;

				case 'internalcollaborator':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1)");
				$permContact=6;
				break;

				case 'collaboratorcustomer':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1)");
				$permContact=5;
				break;

				case 'executive':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1)");
				$permContact=4;
				break;

				case 'manager':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 0, 1, 0, 0, 1)");
				$permContact=3;
				break;

				case 'administrator':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1)");
				$permContact=2;
				break;

				// NOTE : dans la gestion classique de fengoffice, on a les même droits que administrator. Ici nous mettons tout les droits à superadminstrator.
				case 'superadministrator':
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1)");
				$permContact=1;
				break;

				default:	// Par défaut equ "guest"
				$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "system_permissions VALUES ('$pg_id', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)");
				$permContact=12;
				break;
			}
			if ($dbfeng->errno!=0) print "!!!#3:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Cree le contact correspondant dans sa société
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contacts VALUES ('$ob_id', '$nom', '$prenom', 0, '$idSociete', '', '', '0000-00-00 00:00:00', '1.0', '$permContact', 0, '', '', '', '$nom $prenom', '$pg_id', '$uid', 0, '', '', '', now(), now(), now(), 0, 0, 0)");
			if ($dbfeng->errno!=0) print "!!!#4:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Cree le membre et récupère l'id
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "members VALUES (null, 1, 20, 1, 2, '$nom $prenom', '$ob_id', 0, 0, '0000-00-00 00:00:00', 0)");
			if ($dbfeng->errno!=0) print "!!!#5:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$me_id = mysql_insert_id();
	
			// Cree les liens pour le groupe personnalisé
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','time-panel')");
			if ($dbfeng->errno!=0) print "!!!#6:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','tasks-panel')");
			if ($dbfeng->errno!=0) print "!!!#7:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','reporting-panel')");
			if ($dbfeng->errno!=0) print "!!!#8:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','overview-panel')");
			if ($dbfeng->errno!=0) print "!!!#9:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','more-panel')");
			if ($dbfeng->errno!=0) print "!!!#10:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','messages-panel')");
			if ($dbfeng->errno!=0) print "!!!#11:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','mails-panel')");
			if ($dbfeng->errno!=0) print "!!!#12:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','documents-panel')");
			if ($dbfeng->errno!=0) print "!!!#13:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','contacts-panel')");
			if ($dbfeng->errno!=0) print "!!!#14:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "tab_panel_permissions VALUES ('$pg_id','calendar-panel')");
			if ($dbfeng->errno!=0) print "!!!#15:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// ????
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "object_members VALUES ('$ob_id', 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#16:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "object_members VALUES ('$ob_id', '$me_id', 0)");
			if ($dbfeng->errno!=0) print "!!!#17:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Permissions du groupe 
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_permission_groups VALUES ('$ob_id', '$pg_id')");
			if ($dbfeng->errno!=0) print "!!!#18:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Cache du contact
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_cache VALUES ('$ob_id', '$me_id', 1, '0000-00-00 00:00:00')");
			if ($dbfeng->errno!=0) print "!!!#19:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Permissions pour le membre : voir table fo_object_types pour la 3ème valeur
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 19, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#20:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 18, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#21:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 17, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#22:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 16, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#23:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 15, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#24:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 13, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#25:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 12, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#26:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 11, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#27:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id', 10, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#38:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id',  9, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#29:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id',  6, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#30:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id',  5, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#31:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id',  4, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#32:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_member_permissions VALUES ('$pg_id', '$me_id',  3, 1, 1)");
			if ($dbfeng->errno!=0) print "!!!#33:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Email de contact
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_emails VALUES (null, '$ob_id', 2, '$mail', 1)");
			if ($dbfeng->errno!=0) print "!!!#34:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Permissions de dimensions .....
			//$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_dimension_permissions VALUES ('$pg_id', 1, 'check')");
			//if ($dbfeng->errno!=0) print "!!!#35:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_dimension_permissions VALUES ('$pg_id', 2, 'check')");
			if ($dbfeng->errno!=0) print "!!!#36:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// .......
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "sharing_table VALUES (14, '$ob_id')");
			if ($dbfeng->errno!=0) print "!!!#37:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "searchable_objects VALUES ('$ob_id', 'name', '$nom $prenom', 0)");
			if ($dbfeng->errno!=0) print "!!!#38:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Reinitialisation du mdp local par un mot de passe aléatoire et donc inconnu
			$mdpAleas = md5(uniqid(rand(), true));
			$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_passwords VALUES (null, '$ob_id', '" . $mdpAleas . "',  now())");
			if ($dbfeng->errno!=0) print "!!!#39:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			setPassword($uid, $mdpAleas);
		}
		// Si il existe déjà, on fait la maj
		else
		{
			// Récupère l'object_id du user
			$ob_id = $dbfeng->f("object_id");
			// Maj du nom et prénom dans la table des objets
			$dbfeng->query("UPDATE " . TABLE_PREFIX . "objects SET name='$nom $prenom' WHERE id='$ob_id'");
			if ($dbfeng->errno!=0) print "!!!#40:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Récupère le permission_group_id et fait les traitements relatifs
			$dbfeng->query("SELECT id FROM " . TABLE_PREFIX . "permission_groups WHERE contact_id='$ob_id'");
			if ($dbfeng->errno!=0) print "!!!#41:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			if($dbfeng->next_record() )
			{	
				$pg_id = $dbfeng->f("id");
				switch ($role)
				{
					case 'guest':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=0, can_manage_configuration=0, can_manage_templates=0, can_manage_time=0, can_add_mail_accounts=0, can_manage_dimensions=0, can_manage_dimension_members=0, can_manage_tasks=0, can_task_assignee=0, can_manage_billing=0, can_view_billing=0, can_see_assigned_to_other_tasks=0, can_manage_contacts=0, can_update_other_users_invitations=0, can_link_objects=0 WHERE permission_group_id='$pg_id'");
					break;

					case 'guestcustomer':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=0, can_manage_configuration=0, can_manage_templates=0, can_manage_time=0, can_add_mail_accounts=0, can_manage_dimensions=0, can_manage_dimension_members=0, can_manage_tasks=0, can_task_assignee=0, can_manage_billing=0, can_view_billing=0, can_see_assigned_to_other_tasks=1, can_manage_contacts=0, can_update_other_users_invitations=0, can_link_objects=0 WHERE permission_group_id='$pg_id'");
					break;

					case 'externalcollaborator':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=0, can_manage_configuration=0, can_manage_templates=0, can_manage_time=0, can_add_mail_accounts=0, can_manage_dimensions=0, can_manage_dimension_members=0, can_manage_tasks=0, can_task_assignee=1, can_manage_billing=0, can_view_billing=0, can_see_assigned_to_other_tasks=0, can_manage_contacts=0, can_update_other_users_invitations=0, can_link_objects=1 WHERE permission_group_id='$pg_id'");
					break;

					case 'internalcollaborator':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=0, can_manage_configuration=0, can_manage_templates=0, can_manage_time=0, can_add_mail_accounts=0, can_manage_dimensions=0, can_manage_dimension_members=0, can_manage_tasks=0, can_task_assignee=1, can_manage_billing=0, can_view_billing=0, can_see_assigned_to_other_tasks=1, can_manage_contacts=0, can_update_other_users_invitations=0, can_link_objects=1 WHERE permission_group_id='$pg_id'");
					break;

					case 'collaboratorcustomer':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=0, can_manage_configuration=0, can_manage_templates=0, can_manage_time=0, can_add_mail_accounts=0, can_manage_dimensions=0, can_manage_dimension_members=0, can_manage_tasks=0, can_task_assignee=1, can_manage_billing=0, can_view_billing=0, can_see_assigned_to_other_tasks=0, can_manage_contacts=0, can_update_other_users_invitations=0, can_link_objects=1 WHERE permission_group_id='$pg_id'");
					break;

					case 'executive':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=1, can_manage_configuration=0, can_manage_templates=0, can_manage_time=0, can_add_mail_accounts=1, can_manage_dimensions=0, can_manage_dimension_members=1, can_manage_tasks=0, can_task_assignee=1, can_manage_billing=0, can_view_billing=0, can_see_assigned_to_other_tasks=1, can_manage_contacts=0, can_update_other_users_invitations=0, can_link_objects=1 WHERE permission_group_id='$pg_id'");
					break;

					case 'manager':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=1, can_manage_configuration=0, can_manage_templates=1, can_manage_time=1, can_add_mail_accounts=1, can_manage_dimensions=0, can_manage_dimension_members=1, can_manage_tasks=1, can_task_assignee=1, can_manage_billing=1, can_view_billing=0, can_see_assigned_to_other_tasks=1, can_manage_contacts=0, can_update_other_users_invitations=0, can_link_objects=1 WHERE permission_group_id='$pg_id'");
					break;

					case 'administrator':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=1, can_manage_configuration=1, can_manage_templates=1, can_manage_time=1, can_add_mail_accounts=1, can_manage_dimensions=1, can_manage_dimension_members=1, can_manage_tasks=1, can_task_assignee=1, can_manage_billing=1, can_view_billing=0, can_see_assigned_to_other_tasks=1, can_manage_contacts=0, can_update_other_users_invitations=1, can_link_objects=1 WHERE permission_group_id='$pg_id'");
					break;

					// NOTE : dans la gestion classique de fengoffice, on a les même droits que administrator. Ici nous mettons tout les droits à superadminstrator.
					case 'superadministrator':
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=1, can_manage_configuration=1, can_manage_templates=1, can_manage_time=1, can_add_mail_accounts=1, can_manage_dimensions=1, can_manage_dimension_members=1, can_manage_tasks=1, can_task_assignee=1, can_manage_billing=1, can_view_billing=1, can_see_assigned_to_other_tasks=1, can_manage_contacts=1, can_update_other_users_invitations=1, can_link_objects=1 WHERE permission_group_id='$pg_id'");
					break;

					default:	// Par défaut equ "guest"
					$dbfeng->query("UPDATE " . TABLE_PREFIX . "system_permissions  SET can_manage_security=0, can_manage_configuration=0, can_manage_templates=0, can_manage_time=0, can_add_mail_accounts=0, can_manage_dimensions=0, can_manage_dimension_members=0, can_manage_tasks=0, can_task_assignee=0, can_manage_billing=0, can_view_billing=0, can_see_assigned_to_other_tasks=0, can_manage_contacts=0, can_update_other_users_invitations=0, can_link_objects=0 WHERE permission_group_id='$pg_id'");
					break;
				}
				if ($dbfeng->errno!=0) print "!!!#42:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			}

			// Mise à jour de la table des membres
			$dbfeng->query("UPDATE " . TABLE_PREFIX . "members SET name='$nom $prenom' WHERE `object_id`='$ob_id' AND object_type_id='20'");
			if ($dbfeng->errno!=0) print "!!!#43:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			// Mise à jour de la table des objets de recherche
			$dbfeng->query("UPDATE " . TABLE_PREFIX . "searchable_objects SET content='$nom $prenom' WHERE `rel_object_id`='$ob_id'");
			if ($dbfeng->errno!=0) print "!!!#44:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			// Mise à jour de la table des objets de recherche
			$dbfeng->query("UPDATE " . TABLE_PREFIX . "contact_emails SET email_address='$mail' WHERE `contact_id`='$ob_id'");
			if ($dbfeng->errno!=0) print "!!!#45:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Mise à jour de la fiche de contact
			$permContact=12;
			switch ($role)
			{
				case 'guest':
				$permContact=12;
				break;

				case 'guestcustomer':
				$permContact=11;
				break;

				case 'externalcollaborator':
				$permContact=7;
				break;

				case 'internalcollaborator':
				$permContact=6;
				break;

				case 'collaboratorcustomer':
				$permContact=5;
				break;

				case 'executive':
				$permContact=4;
				break;

				case 'manager':
				$permContact=3;
				break;

				case 'administrator':
				$permContact=2;
				break;

				case 'superadministrator':
				$permContact=1;
				break;

				default:	// Par défaut equ "guest"
				$permContact=12;
				break;
			}
			$dbfeng->query("UPDATE " . TABLE_PREFIX . "contacts SET first_name='$nom', surname='$prenom', company_id='$idSociete', user_type='$permContact', display_name='$nom $prenom' WHERE username='$uid'");
			if ($dbfeng->errno!=0) print "!!!#46:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

			// Reinitialisation du mdp local par un mot de passe aléatoire et donc inconnu
			// Inutile car ne servira jamais mais doit-être fait à la création du user sinon, il ne se connectera pas
			//$mdpAleas = md5(uniqid(rand(), true));
			//$dbfeng->query("INSERT INTO " . TABLE_PREFIX . "contact_passwords VALUES (null, '$ob_id', '" . $mdpAleas . "',  now())");
			//if ($dbfeng->errno!=0) print "!!!#47:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			//setPassword($uid, $mdpAleas);
		}
	}

	// Réalisation du mot de passe à la sauce fengoffice (inspirée de application/models/contacts/Contact.class.php et remodifiée)
	function setPassword($uid, $value) 
	{
		// Variable globale de la DB
		global $dbfeng;
		// Génère le token unique
		do 
		{
			$salt = substr ( sha1 ( uniqid ( rand (), true ) ), rand ( 0, 25 ), 13 );
			$token = sha1 ( $salt . $value );
		} 
		while ( tokenExists ( $token ) );
		// Mise à jour de la base
		$dbfeng->query("UPDATE " . TABLE_PREFIX . "contacts SET token='$token', salt='$salt', twister='" . getTwister() . "' WHERE username='$uid'");
		if ($dbfeng->errno!=0) print "!!!#48:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
	} 

	// Vérifie si le même token existe déjà
	function tokenExists ($token)
	{
		// Variable globale de la DB
		global $dbfeng;
		$dbfeng->query("SELECT token FROM " . TABLE_PREFIX . "contacts WHERE token='$token'");
		if ($dbfeng->errno!=0) print "!!!#49:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
		if(! $dbfeng->next_record() ) return (false);
		else return (true);
	}

	// Réalisiation du champ twister  (extrait de environnements/classes/StringTwister.class.php)
	function getTwister() 
	{
      		$twister = array('1', '2', '3', '4', '5', '6', '7', '8', '9', '0');
      		do 
		{
        		shuffle($twister);
      		} 
		while($twister[0] == '0');
      		return implode('', $twister);
	}	

	// Suprresion d'un utilisateur fengoffice
	function supprimerUserFengoffice ($idSociete, $user)
	{
		// Récup variable globale de l'objet de base de données
		global $dbfeng;
		
		// Protection des champs à inserer par des addSlashes
		$idSociete = addSlashes ($idSociete);
		$user = addSlashes ($user);
		
		// Mémorise les id necessaires
		$ob_id="";
		$pg_id="";
		$me_id="";

		// Vérifie d'abord que l'utilisateur existe
		$dbfeng->query("SELECT object_id FROM " . TABLE_PREFIX . "contacts WHERE username='$user' AND is_company='0'");
		if ($dbfeng->errno!=0) print "!!!#1:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
		// Si il n'existe pas averti
		if(!$dbfeng->next_record()) AfficheLigne("L'utilisateur $user n'a pas été trouvé !!!");
		// Si il existe
		else
		{
			// Récupère l'object_id de l'utilisateur
			$ob_id = $dbfeng->f("object_id");
			// Récupère le permission group id de cet utilisateur
			$dbfeng->query("SELECT id FROM " . TABLE_PREFIX . "permission_groups WHERE contact_id='$ob_id'");
			if ($dbfeng->errno!=0) print "!!!#2:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			if($dbfeng->next_record()) $pg_id = $dbfeng->f("id");
			// Récupère le member id de cet utilisateur
			$dbfeng->query("SELECT id FROM " . TABLE_PREFIX . "members WHERE object_id='$ob_id'");
			if ($dbfeng->errno!=0) print "!!!#3:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			if($dbfeng->next_record()) $me_id = $dbfeng->f("id");

			// Les 2 identifiants me_id et pg_id doivent être connus
			if ($pg_id=="" || $me_id=="") AfficheLigne("L'utilisateur $user a été trouvé (object_id='$ob_id') mais pg_id='$pg_id' et me_id='$me_id' !!!");
			else
			{
				// Debug
				//AfficheLigne("L'utilisateur $user a été trouvé object_id='$ob_id', pg_id='$pg_id' et me_id='$me_id'");

				// A partir d'ici on détruit dans le même ordre que la création du user :
				// Destruction dans la table des objets
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "objects WHERE id='$ob_id'");
				if ($dbfeng->errno!=0) print "!!!#4:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Destruction du groupe de permissions personnel : NON UTILISEE car non détruite par l'application elle-même si destruction locale
				//$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "permission_groups WHERE contact_id='$ob_id'");
				//if ($dbfeng->errno!=0) print "!!!#5:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Destruction des permissions system relative au groupe personnel
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "system_permissions WHERE permission_group_id='$pg_id'");
				if ($dbfeng->errno!=0) print "!!!#6:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Detruit le contact correspondant dans sa société
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "contacts WHERE object_id='$ob_id' AND company_id='$idSociete'");
				if ($dbfeng->errno!=0) print "!!!#7:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// détruit le membre
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "members WHERE id='$me_id' AND object_id='$ob_id'");
				if ($dbfeng->errno!=0) print "!!!#8:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Supprime les liens de groupes personnalisés
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "tab_panel_permissions WHERE permission_group_id='$pg_id'");
				if ($dbfeng->errno!=0) print "!!!#9:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
				
				// ????
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "object_members WHERE object_id='$ob_id'");
				if ($dbfeng->errno!=0) print "!!!#10:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Supprime les permissions du groupe 
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "contact_permission_groups WHERE contact_id='$ob_id' AND permission_group_id='$pg_id'");
				if ($dbfeng->errno!=0) print "!!!#11:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Nettoyage cache du contact
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "contact_member_cache  WHERE contact_id='$ob_id' AND member_id='$me_id'");
				if ($dbfeng->errno!=0) print "!!!#12:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Nettoyage permissions pour le membre
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "contact_member_permissions WHERE permission_group_id='$pg_id' OR member_id='$me_id'");
				//if ($dbfeng->errno!=0) print "!!!#13:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Suppression email de contact
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "contact_emails WHERE contact_id='$ob_id'");
				if ($dbfeng->errno!=0) print "!!!#14:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Suppression permissions de dimensions .....
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "contact_dimension_permissions WHERE permission_group_id='$pg_id'");
				if ($dbfeng->errno!=0) print "!!!#15:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Suppression ......
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "sharing_table WHERE object_id='$ob_id'");
				if ($dbfeng->errno!=0) print "!!!#16:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Suppression ......
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "searchable_objects WHERE rel_object_id='$ob_id'");
				if ($dbfeng->errno!=0) print "!!!#17:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Suppression fiche mot de passe de contact (même si il est généré aléatoirement et ne sert à rien dans le cas d'Envole)
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "contact_passwords WHERE contact_id='$ob_id'");
				if ($dbfeng->errno!=0) print "!!!#18:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";

				// Suppression des options de contact 
				$dbfeng->query("DELETE FROM " . TABLE_PREFIX . "contact_config_option_values WHERE contact_id='$ob_id'");
				if ($dbfeng->errno!=0) print "!!!#19:" . $dbfeng->errno . " : " . $dbfeng->error . "!!!";
			}
		}
	}
	
//==MAIN BLOCK=========================================================================================================================================
	
	$ds = ldap_connect ( $config['LDAPserver'], $config['LDAPport'] );
	if (!$ds) {
		AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
		die();
	}
	$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
    if (!$r) {
		AfficheLigne("Erreur authentification : impossible de se connecter à l'annuaire LDAP");
		die();
    }

	$dbfeng->query("SELECT object_id, first_name FROM fo_contacts WHERE is_company = '1'");
	while($dbfeng->next_record()) {
		$id=$dbfeng->f('object_id');
		
		$dbprof->query("SELECT * FROM pia_fengoffice WHERE id=$id");
		if(!$dbprof->next_record()||!$dbprof->f("synchro_user"))
		{
			AfficheTitre("SYNCHRONISATION SOCIETE = ".$dbfeng->f('first_name'));
			AfficheLigne("Synchronisation désactivée");
		}
		else 
		{
			AfficheTitre("SYNCHRONISATION SOCIETE = ".$dbfeng->f('first_name'));
			
			// Mise à jour des roles ldap_guest
			if($dbprof->f("ldap_guest")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs Guest");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_guest"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
					
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "guest", $nom[0], $prenom[0], $mail[0]);
				}
			}

			// Mise à jour des roles ldap_guestcustomer
			if($dbprof->f("ldap_guestcustomer")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs Guest Customer");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_guestcustomer"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
		
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "guestcustomer", $nom[0], $prenom[0], $mail[0]);
				}
			}

			// Mise à jour des roles ldap_externalcollaborator
			if($dbprof->f("ldap_externalcollaborator")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs External Colloborator");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_externalcollaborator"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
					
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "externalcollaborator", $nom[0], $prenom[0], $mail[0]);
				}
			}


			// Mise à jour des roles ldap_internalcollaborator
			if($dbprof->f("ldap_internalcollaborator")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs Internal Collaborator");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_internalcollaborator"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
		
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "internalcollaborator", $nom[0], $prenom[0], $mail[0]);
				}
			}

			// Mise à jour des roles ldap_collaboratorcustomer
			if($dbprof->f("ldap_collaboratorcustomer")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs Collaborator Customer");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_collaboratorcustomer"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
		
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "collaboratorcustomer", $nom[0], $prenom[0], $mail[0]);
				}
			}

			// Mise à jour des roles ldap_executive
			if($dbprof->f("ldap_executive")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs Executive");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_executive"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
		
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "executive", $nom[0], $prenom[0], $mail[0]);
				}
			}

			// Mise à jour des roles ldap_manager
			if($dbprof->f("ldap_manager")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs Manager");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_manager"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
		
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "manager", $nom[0], $prenom[0], $mail[0]);
				}
			}

			// Mise à jour des roles ldap_administrator
			if($dbprof->f("ldap_administrator")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs Administrator");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_administrator"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
		
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "administrator", $nom[0], $prenom[0], $mail[0]);
				}
			}

			// Mise à jour des roles ldap_superadministrator
			if($dbprof->f("ldap_superadministrator")!="") {
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des utilisateurs Super Administrator");
				
				$res = ldap_search($ds,$config['LDAPracine'],$dbprof->f("ldap_superadministrator"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
		
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "superadministrator", $nom[0], $prenom[0], $mail[0]);
				}
			}

			// Ajout du 2nd admin
			if ($config['uid_addadmin']!="")
			{
				AfficheLigne("");
				AfficheLigneGras("Synchronisation des droits du second admin");

				$res = ldap_search($ds,$config['LDAPracine'], "(uid=" . $config['uid_addadmin'] . ")");
				$entryID=ldap_first_entry($ds,$res);
				if ($entryID != false)
				{
					$uid		= ldap_get_values($ds,$entryID,'uid');
					$nom		= ldap_get_values($ds,$entryID,'sn');
					$prenom		= ldap_get_values($ds,$entryID,'givenName');
					$mail		= ldap_get_values($ds,$entryID,'mail');
		
					AfficheLigne($uid[0]." = ".$prenom[0]. " ".$nom[0]);
					creerUserFengoffice ($id, $uid[0], "superadministrator", $nom[0], $prenom[0], $mail[0]);
				}
			}


		
			// Détacher les utilisateur de la société
			if($dbprof->f("del_user")==1) {
				AfficheLigne("");
				AfficheLigneGras("Suppression des utilisateurs non présent dans l'annuaire");

				$dbfeng->query("SELECT username FROM " . TABLE_PREFIX . "contacts WHERE company_id='$id' AND is_company='0'");
				while($dbfeng->next_record()) 
				{
					$user=$dbfeng->f('username');
					$rechercheUser = preg_replace('/#login#/', $user, $dbprof->f("ldap_user"));
					$res = ldap_search($ds,$config['LDAPracine'], $rechercheUser);
					$trouveLdap=false;
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{
						$uid = ldap_get_values($ds,$entryID,'uid');
						if ($uid[0] == $user) $trouveLdap=true;
					}
					// Si pas trouvé dans ldap, le supprimer dans fengoffice
					if (!$trouveLdap)
					{
						AfficheLigne("Suppression de $user dans fengoffice");
						supprimerUserFengoffice ($id, $user);
					}
				}
			}
		}
		
		AfficheLigne("");
		AfficheLigne("");
		AfficheLigne("");
	}

	// On parcourt l'ensemble des utilisateurs et si présent dans zéro société on sucre
	// AfficheTitre("PURGE UTILISATEUR");
?>
