<?
	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		parse_str($argv[2], $param);
	}
	
	// Include minimum pour posh-profil
	$PATH="../";
	include_once($PATH."include/include.php");
	include_once($PATH."include/admin.php");															/* Page Admin		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");		/* Entete HTML		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");	/* Entete HTML		*/
	
	$db1=new ps_db;
	$dbtask=new ps_db;
	$dbtask2=new ps_db;
	
	$dbtask->dbname("taskfreak");
	$dbtask2->dbname("taskfreak");
	
	set_time_limit(600);
	
//==FUNCTION===========================================================================================================================================
	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}


	// Determine le role wordpress par rapport au parametre poshprofil
	function labelRole($idrole) {
	
		switch($idrole){
			
			case 0: $labelrole="Aucun"; break;
			case 1: $labelrole="Invité"; break;
			case 2: $labelrole="Officiel"; break;
			case 3: $labelrole="Membre"; break;
			case 4: $labelrole="Modérateur"; break;
			case 5: $labelrole="Responsable"; break;
		}
		
		return $labelrole;
	}
	
	// Determine en fonction du profil sso le profil wordpress
	function Profil($uid, $ENTProfil) {
		global $db1;
		$tbprofil=array('role' => '','sentry' => '');

		if($uid=="admin"){
			$tbProfil['role']	=labelRole($db1->f("perm_administrateur"));
			$tbProfil['id']		=$db1->f("perm_administrateur");
		}
		else {
			switch($ENTProfil){
				case "eleve": 
					$tbProfil['role']	= labelRole($db1->f("perm_eleve"));
					$tbProfil['id']		= $db1->f("perm_eleve");
					break;
				
				case "responsable": 
					$tbProfil['role']	=labelRole($db1->f("perm_responsable"));
					$tbProfil['id']		=$db1->f("perm_responsable");
					break;
								
				case "administratif":
					$tbProfil['role']	=labelRole($db1->f("perm_administratif"));
					$tbProfil['id']		=$db1->f("perm_administratif");
					break;

				case "enseignant":
					$tbProfil['role']	=labelRole($db1->f("perm_administratif"));
					
					switch($uid){
						case "Visiteur":	$tbProfil['id']=$db1->f("perm_visiteur");break;
						case "Meta_eleve":	$tbProfil['id']=$db1->f("perm_eleve");break;
						case "Meta_parent":	$tbProfil['id']=$db1->f("perm_responsable");break;
						case "Meta_prof":	$tbProfil['id']=$db1->f("perm_administratif");break;
						case "Meta_perdir":	$tbProfil['id']=$db1->f("perm_administratif");break;
						default : 			$tbProfil['id']=$db1->f("perm_administratif");
					}
					break;
				
				case "administrateur":
					$tbProfil['role']	=labelRole($db1->f("perm_administrateur"));
					$tbProfil['id']		=$db1->f("perm_administrateur");
					break;
				
				case "visiteur":
				default : 
					$tbProfil['role']	=labelRole($db1->f("perm_visiteur"));
					$tbProfil['id']	=$db1->f("perm_visiteur");
					break;
			}	
		}
		
	    return $tbProfil;	
	}

	function CreateUser($login,$nom,$prenom,$mail,$position,$labelposition) {
		global $dbtask;
		global $dbtask2;
		
		$niveau=3;
		if($login=='admin') $niveau=4;
		
		// On recherche si l'utilisateur existe déjà
		$dbtask->query("SELECT * FROM frk_member WHERE username='$login'");
		if(!$dbtask->next_record()) {
			AfficheLigne("Creation Utilisateur = ".$login);
			$dbtask->query("INSERT INTO frk_member (email,firstName,lastName,countryid,username,level,enabled) VALUES('$mail','$prenom','$nom','FR','$login',$niveau,1)");
		}
		else {
			if(utf8_encode($nom)!=$dbtask->f("lastName")||utf8_encode($prenom)!=$dbtask->f("firstName")||$mail!=$dbtask->f("email")||$niveau!=$dbtask->f("level")||1!=$dbtask->f("enabled")) {
				AfficheLigne("Mise à jour Utilisateur = ".$login." ".$prenom." ".utf8_encode($dbtask->f("firstName")));
				$dbtask->query("UPDATE frk_member SET email='$mail',firstName='".utf8_encode($prenom)."',lastName='".utf8_encode($nom)."',countryid='FR',level=$niveau,enabled=1 WHERE username='$login'");
			}
		}
		
		// Affecter l'utilisateur à l'ensemble des projets en fonction de la sa position
		$dbtask->query("SELECT * FROM frk_member WHERE username='$login'");
		if($dbtask->next_record()) {
			$memberId=$dbtask->f("memberId");		
		
			if($position==0) {
				$dbtask->query("DELETE FROM frk_memberProject WHERE memberId=$memberId");
			}
			else {
				$dbtask->query("SELECT projectId FROM frk_project");
				while($dbtask->next_record()) {
					$projectId=$dbtask->f("projectId");
					$dbtask2->query("SELECT * FROM frk_memberProject WHERE projectId=$projectId AND memberId=$memberId");
					if(!$dbtask2->next_record()) {
						$dbtask2->query("INSERT INTO frk_memberProject (projectId,memberId,position) VALUES('$projectId','$memberId','$position')");
					}
					else {
						$dbtask2->query("UPDATE frk_memberProject SET projectId=$projectId,memberId=$memberId,position=$position WHERE projectId=$projectId AND memberId=$memberId");
					}
				}
			}
		}
	}
	
	
//==MAIN BLOCK=========================================================================================================================================
	
	$ds = ldap_connect ( $config['LDAPserver'], $config['LDAPport'] );
	if (!$ds) {
		AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
		die();
	}
	$r=ldap_bind($ds);	
	
	// Récupération des valeurs stockées

	$db1->query("SELECT * FROM admin_taskfreak WHERE id=1");
	if($db1->next_record()) {
		AfficheTitre("SYNCHRONISATION TASKFREAK");
		
		if(!$db1->f("synchro_user"))
			AfficheLigne("Synchronisation désactivée");
		else {
			
			switch($db1->f("idsynchro")) {
				// Synchronisation sur l'ensemble des utilisateurs
				case -1:
					// Creation
					AfficheLigneGras("Création des utilisateurs");
					
					$res = ldap_search($ds,$config['LDAPracine'],"(&(uid=*)(objectclass=inetOrgPerson)(!(description=Computer)))");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{					
						$uid		= ldap_get_values($ds,$entryID,'uid');
						$nom		= ldap_get_values($ds,$entryID,'sn');
						$prenom		= ldap_get_values($ds,$entryID,'givenName');
						$mail		= ldap_get_values($ds,$entryID,'mail');
						
						@$ENTprofil	= ldap_get_values($ds,$entryID,'ENTPersonProfils');
						$profil		= array('role' => '','id' => '');
						$profil		= Profil($uid[0],$ENTprofil[0]);
						
						
						CreateUser($uid[0],$nom[0],$prenom[0],$mail[0],$profil['id'],$profil['role']);
					}
					
					// Suppression
					if($db1->f("del_user")) {
						AfficheLigne("");
						AfficheLigneGras("Suppression des utilisateurs obsolètes");

					}
					
				break;
				
				// Synchronisation sur les parents
				case 0:
					AfficheLigneGras("Rattachement des utilisateurs ".$db1->f("labelsynchro")." sur le site");
				
					$res = ldap_search($ds,$config['LDAPracine'],"ENTPersonProfils=responsable");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{
						
					}				

					// Ajouter quoi qu'il arrive l'utilisateur admin
					$res = ldap_search($ds,$config['LDAPracine'],"uid=admin");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{
						
					}
					
					// Suppression
					if($db1->f("del_user")) {
						AfficheLigne("");
						AfficheLigneGras("Détacher les utilisateurs du site");

					}						
					
					break;
					
				// Synchronisation sur les autres groupes
				default:
					AfficheLigneGras("attachement des utilisateurs ".$db1->f("labelsynchro")." sur le site");

					$res = ldap_search($ds,$config['LDAPracine'],"(&(gidNumber=".$db1->f("idsynchro").")(type=*))");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{
						$cn			= ldap_get_values($ds,$entryID,'cn');						
						@$member	= ldap_get_values($ds,$entryID,'memberUid');

						for ($i=0; $i<count($member); $i++) {
							if($member[$i]!="") {
								$res2 = ldap_search($ds,$config['LDAPracine'],"uid=".$member[$i]);
								for ($entryID2=ldap_first_entry($ds,$res2);$entryID2!=false;$entryID2=ldap_next_entry($ds,$entryID2))
								{
									
								}
							}
						}
					}	
					
					// Ajouter quoi qu'il arrive l'utilisateur admin
					$res = ldap_search($ds,$config['LDAPracine'],"uid=admin");
					for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
					{

					}
					
					// Suppression
					if($db1->f("del_user")) {
						AfficheLigne("");
						AfficheLigneGras("Détacher les utilisateurs du site");
					}
					
					break;
			}
		}
		
		AfficheLigne("");
		AfficheLigne("");
		AfficheLigne("");
	
	
	}
	
?>
