<?
	$_SERVER['REQUEST_URI']="/wordpress";
	$PATH="../";	
	include_once($PATH."include/envole.php");

	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		parse_str($argv[2], $param);
		//$_SERVER[ 'HTTP_HOST' ] = "amonecole23.ac-arno.fr";
		$_SERVER[ 'HTTP_HOST' ] = $config['host']; // Orléans
	}
	
	// Include général de wordpress
	include_once('../../wordpress/wp-load.php');
	require_wp_db();	
	include_once('../../wordpress/wp-admin/includes/user.php');

	// Permet d'ignorer les erreurs wordpress dans le cas plusieurs utilisateurs auraient le meme email
	define('WP_IMPORTING', true);

	// Include minimum pour posh-profil
	include_once($PATH."include/mysql.php");
	include_once($PATH."include/admin.php");
	include_once($PATH."include/session.php");
	if($_SESSION['user_login']=="") $_SESSION['user_login']="UserCron";
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");

	$db1=new ps_db;
	$db2=new ps_db;
	
	global $wpdb;
	set_time_limit(60000);
	
//==FUNCTION===========================================================================================================================================
	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}
	
	function AfficheContinue($label) {
		echo $label;
	 }

	// Liste des sites
	function my_get_blog_list( $start = 0, $num = 10, $deprecated = '' ) {
		_deprecated_function( __FUNCTION__, '3.0' );

		global $wpdb;
		$blogs = $wpdb->get_results( $wpdb->prepare("SELECT blog_id, domain, path FROM $wpdb->blogs WHERE site_id = %d AND archived = '0' AND mature = '0' AND spam = '0' AND deleted = '0' ORDER BY registered DESC", $wpdb->siteid), ARRAY_A );
		
		foreach ( (array) $blogs as $details ) {
			$blog_list[ $details['blog_id'] ] = $details;
			$blog_list[ $details['blog_id'] ]['postcount'] = $wpdb->get_var( "SELECT COUNT(ID) FROM " . $wpdb->get_blog_prefix( $details['blog_id'] ). "posts WHERE post_status='publish' AND post_type='post'" );
		}
		unset( $blogs );
		$blogs = $blog_list;

		if ( false == is_array( $blogs ) )
			return array();

		if ( $num == 'all' )
			return array_slice( $blogs, $start, count( $blogs ) );
		else
			return array_slice( $blogs, $start, $num );
	}	
		
	// Création / Modification des user
	function GenerateUser($id,$ds,$entryID,$role,$role_notchange) {
		$uid		= ldap_get_values($ds,$entryID,'uid');
		$cn			= ldap_get_values($ds,$entryID,'cn');
		$mail		= ldap_get_values($ds,$entryID,'mail');
								
		// Création de l'utilisateur
		// la fonction  get_userdatabylogin est dans /var/www/html/wordpress/wp-includes/pluggable.php
		// s'il n'est pas dans la bd wordpress wp_users il est créé.
		if (!$user=get_userdatabylogin($uid[0])){
			$user_id = wp_create_user($uid[0], $pass[0], $mail[0]);	
		}
		else{
			$user_id=$user->ID;
		}
		
		// Modification de l'utilisateur
		// s'il est  dans la bd wordpress wp_users il est mis ajour.
		wp_update_user(array ('ID' => $user_id, 'user_email' => $mail[0]));
		
		if(is_user_member_of_blog( $user_id, $id ) AND !($role_notchange)){
			AfficheLigne("Utilisateur = $uid[0] = Ne pas modifier");
		}	
		else {
			AfficheLigne("Utilisateur = $uid[0] > $role");
			add_user_to_blog( $id, $user_id, $role);
		}
	}

	// rattachement d'un utilisateur à groupe wp-sentry d'un site
	function AtacheUserSentry($id,$groupe,$user_id) {
		global $wpdb;
		
	    // plugin groupe wp-sentry
        if($groupe!=""){
            // construire le nom de la table wp_sentry associée au blog
            $blog_tb="wp_";
            if($id > 1) $blog_tb="wp_".$id."_";
			
            // recherche du groupe wp_sentry associé
	        $group = $wpdb->get_row("SELECT * FROM ".$blog_tb."sentry_groups WHERE name=\"".$groupe."\"");
            $gid=$group->id;
			
            // si le groupe n'existe pas, on le génère
            if($gid=="") {
                $sql="INSERT INTO ".$blog_tb."sentry_groups(name) VALUES(\"".$groupe."\")";
                $wpdb->query($sql);
				
                $group = $wpdb->get_row("SELECT * FROM ".$blog_tb."sentry_groups WHERE name=\"".$groupe."\"");
                $gid=$group->id;
            }

            // On affecte la personne au groupe wp_sentry
			if ($group->member_list!="") $group_members = explode(',', $group->member_list); 
			else $group_members = array();
		  
			if(!in_array($user_id, $group_members)) array_push($group_members,$user_id);
			$group->member_list=implode(',',$group_members);

			$sql="UPDATE ".$blog_tb."sentry_groups SET member_list=\"".$group->member_list."\" WHERE id=$gid";
			$wpdb->query($sql);	        
	    }				    
	}
	
	
	// Liste des groupes
	function ListeGroupSentry($id) {
		global $wpdb;
		
		// construire le nom de la table wp_sentry associée au blog
		$blog_tb="wp_";
		if($id > 1) $blog_tb="wp_".$id."_";
		
		$groups = $wpdb->get_results("SELECT * FROM ".$blog_tb."sentry_groups");
		
		return $groups;
	}
	
	// detachement d'un utilisateur au groupe wp-sentry
	function DetacheUserSentry($id,$userid) {
		global $wpdb;
		
		// construire le nom de la table wp_sentry associée au blog
		$blog_tb="wp_";
		if($id > 1) $blog_tb="wp_".$id."_";
		
		$groups = $wpdb->get_results("SELECT * FROM ".$blog_tb."sentry_groups");
		foreach($groups as $group) {
			if ($group->member_list!="") {
				$gid=$group->id;
				$group_members = explode(',', $group->member_list); 
				
				if(in_array($userid,$group_members)) {
					$key = array_search($userid, $group_members);
				
					unset($group_members[$key]);
					$group->member_list=implode(',',$group_members);
					$sql="UPDATE ".$blog_tb."sentry_groups SET member_list='".$group->member_list."' WHERE id=$gid";
					$wpdb->query($sql);				
				}
			}
		}
	}
		
	// detachement des utilisateurs à un site
	function DetacheUserBlog($id,$ds,$ldapsearch) {	
		global $config;

		$user=get_userdatabylogin('admin');
		$admin_id=$user->ID;
							
		$ldapsearch=str_replace("()","",$ldapsearch);
				
		
		// Pour chaque utilisateur du blog on vérifie que l'utilisateur existe toujours
		$blogusers=get_users("blog_id=$id");
		foreach ($blogusers as $user) {
							
			// Ne jamais enlever admin
			if($user->user_login=="admin") {
				AfficheLigne("Utilisateur = ".$user->user_login." = existe toujours");
			}
			else {
				// S'il n'existe pas on le supprime et on attache ses articles à l'utilisateur admin
				$res = ldap_search($ds,$config['LDAPracine'],str_replace("#login#",$user->user_login,$ldapsearch));
				if($entryID=ldap_first_entry($ds,$res))
					AfficheLigne("Utilisateur = ".$user->user_login." = existe toujours");
				else {
					$user_id=$user->ID;
					AfficheLigne("Utilisateur = ".$user->user_login." = supprimé");;
					
					// Détacher l'utilisateur du site
					remove_user_from_blog($user_id,$id,$admin_id);	
					DetacheUserSentry($id,$user_id);	
				}
			}
		}
	}
		
//==MAIN BLOCK=========================================================================================================================================
	
	$ds = ldap_connect ( $config['LDAPserver'], $config['LDAPport'] );
	if (!$ds) {
		AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
		die();
	}
	$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
    if (!$r) {
		AfficheLigne("Erreur authentification : impossible de se connecter à l'annuaire LDAP");
		die();
    }

	$blog_list = my_get_blog_list( 0, "all");
	asort($blog_list);
	foreach ($blog_list AS $blog) {
		AfficheTitre("SYNCHRONISATION SITE = ".$blog['path']);
		$id=$blog['blog_id'];
		
		$db1->query("SELECT * FROM pia_wordpress WHERE id=$id");
		if(!$db1->next_record()||!$db1->f("synchro_user"))
		{
			AfficheLigne("Synchronisation désactivée");
		}
		else 
		{
			// Mise à jour des roles contributeur
			if($db1->f("ldap_abonne")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Abonné");
				
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_abonne"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					GenerateUser($id,$ds,$entryID,"subscriber",$db1->f("role_notchange"));	
				}
			}
			
			// Mise à jour des roles contributeur
			if($db1->f("ldap_contributeur")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Contributeur");
				
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_contributeur"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					GenerateUser($id,$ds,$entryID,"contributor",$db1->f("role_notchange"));	
				}
			}
			
			// Mise à jour des roles auteur
			if($db1->f("ldap_auteur")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Auteur");
				
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_auteur"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					GenerateUser($id,$ds,$entryID,"author",$db1->f("role_notchange"));	
				}
			}
			
			// Mise à jour des roles editeur
			if($db1->f("ldap_editeur")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Editeur");
						
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_editeur"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					GenerateUser($id,$ds,$entryID,"editor",$db1->f("role_notchange"));	
				}
			}
			
			// Mise à jour des roles administrateur
			if($db1->f("ldap_administrateur")!="") {
				AfficheLigne("");
				AfficheLigneGras("Création des utilisateurs Administrateur");
						
				$res = ldap_search($ds,$config['LDAPracine'],$db1->f("ldap_administrateur"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					GenerateUser($id,$ds,$entryID,"administrator",1);	
				}
				
				if(isset($config['uid_addadmin'])) {
    				$res = ldap_search($ds,$config['LDAPracine'],"(uid=".$config['uid_addadmin'].")");
				    for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				    {
					    GenerateUser($id,$ds,$entryID,"administrator",1);	
				    }
				}
			}
			
			// Génération des groupes
			AfficheLigne("");
			AfficheLigneGras("Génération des groupes");
			$db2->query("SELECT * FROM pia_wordpress_group WHERE id=$id");
			while($db2->next_record()) {
				AfficheLigne("Groupes = ".$db2->f("name_group"));
				$res = ldap_search($ds,$config['LDAPracine'],$db2->f("ldap_query"));
				for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
				{
					$uid = ldap_get_values($ds,$entryID,'uid');
					$user=get_userdatabylogin($uid[0]);
					if($user->ID>0) {
						AfficheContinue(" ".$uid[0]);
						AtacheUserSentry($id,$db2->f("name_group"),$user->ID);
					}
				}
				AfficheLigne("");				
			}
			
			// Purge des groupe obsolète
			AfficheLigne("");
			AfficheLigneGras("Suppression des groupes");
			$groups=ListeGroupSentry($id);
			foreach($groups as $group) {
				$blog_tb="wp_";
				if($id > 1) $blog_tb="wp_".$id."_";					

				$db2->query("SELECT * FROM pia_wordpress_group WHERE name_group='".addslashes($group->name)."'");
				if(!$db2->next_record()) {
					AfficheLigne("Groupe = ".$group->name." > supprimé");
					$sql="DELETE FROM ".$blog_tb."sentry_groups WHERE id=".$group->id;
					$wpdb->query($sql);
				}
				else {
					AfficheLigne("Groupe = ".$group->name." > existe toujours");
				}
			}	 			
			
			
			
			// Suppression
			if($db1->f("del_user")==1) {
				AfficheLigne("");
				AfficheLigneGras("Suppression des utilisateurs");				
				DetacheUserBlog($id,$ds,"(&".$db1->f("ldap_user")."(|".$db1->f("ldap_abonne").$db1->f("ldap_contributeur").$db1->f("ldap_auteur").$db1->f("ldap_editeur").$db1->f("ldap_administrateur")."))");
				
				AfficheLigne("");
				AfficheLigneGras("Détacher les utilisateurs des groupes");
				foreach($groups as $group) {
					$db2->query("SELECT * FROM pia_wordpress_group WHERE id=$id AND name_group='".addslashes($group->name)."'");
					if($db2->next_record()) {
						$ldapsearch="(&".$db1->f("ldap_user").$db2->f("ldap_query").")";
						
						if ($group->member_list!="") $group_members = explode(',', $group->member_list); 
						else $group_members = array();
			  
						foreach($group_members as $member) {
							// Récuperer le login du membre
							$user_info = get_userdata($member);
							AfficheContinue($user_info->user_login);
							$res = ldap_search($ds,$config['LDAPracine'],str_replace("#login#",$user_info->user_login,$ldapsearch));
							if($entryID=ldap_first_entry($ds,$res))	{
								AfficheLigne(" = toujours lié au groupe");
							}
							else {
								AfficheLigne(" = détaché au groupe");
								DetacheUserSentry($id,$member);
							}
						}
					}
				}					
			}
		}
		
		AfficheLigne("");
		AfficheLigne("");
		AfficheLigne("");
	}

	// On parcourt l'ensemble des utilisateurs du reseau et si présent dans zéro blog on sucre
	AfficheTitre("PURGE UTILISATEUR RESEAU");

	$user=get_userdatabylogin('admin');
	$admin_id=$user->ID;

	switch_to_blog(0);
	$blogusers=get_users("blog_id=0");
	foreach ($blogusers as $user) {	
		if($user->user_login!="admin") {
			$trouve=false;

			foreach ($blog_list AS $blog) {	
				$blogtrouves=get_users("blog_id=".$blog['blog_id']);
				foreach ($blogtrouves as $usertrouve) {
					if($usertrouve->user_login==$user->user_login) {
						$trouve=true;
						break;
					}
					
					if($trouve) break;
				}
				
				if($trouve) break;
			}

			if($trouve) AfficheLigne("Utilisateur = ".$user->user_login." > existe toujours");
			else {
				$meta = $wpdb->get_col( $wpdb->prepare( "SELECT umeta_id FROM $wpdb->usermeta WHERE user_id = %d", $user->ID ) );
				foreach ( $meta as $mid )
					delete_metadata_by_mid( 'user', $mid );

				$wpdb->delete( $wpdb->users, array( 'ID' => $user->ID ) );					
				
				AfficheLigne("Utilisateur = ".$user->ID." = ".$user->user_login." > supprimé");
			}
		}
	}	
?>
