<?
	
	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		parse_str($argv[2], $param);
	}
	
	$PATH="../";
	include_once($PATH."include/include.php");
	include_once($PATH."include/admin.php");	

	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");		/* Entete HTML		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");	/* Entete HTML		*/

	$dbprf1=new ps_db;
	$dbbal1=new ps_db;
	$dbbal2=new ps_db;
	$dbbal3=new ps_db;

	$dbbal1->dbname("balado");
	$dbbal2->dbname("balado");
	$dbbal3->dbname("balado");

	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}	
	
	function stringToInteger($string) {
		$output = '';
		for ($i = 0; $i < strlen($string); $i++) {
			$output .= (string) ord($string[$i]);
		}
		return $output;
	}

	function recursive_rmdir($dirname, $followLinks = false)
	{
		if (is_dir($dirname) && !is_link($dirname))
		{
			if (!is_writable($dirname))
				throw new Exception('You do not have renaming permissions!');

			$iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($dirname),RecursiveIteratorIterator::CHILD_FIRST);
	 
			while ($iterator->valid())
			{
				if (!$iterator->isDot())
				{
					if (!$iterator->isWritable())
					{
						throw new Exception(sprintf(
							'Permission Denied: %s.',
							$iterator->getPathName()
						));
					}
					if ($iterator->isLink() && false === (boolean) $followLinks)
					{
						$iterator->next();
					}
					if ($iterator->isFile())
					{
						unlink($iterator->getPathName());
					}
					else if ($iterator->isDir())
					{
						rmdir($iterator->getPathName());
					}
				}
	 
				$iterator->next();
			}
			unset($iterator); // Fix for Windows.
	 
			return rmdir($dirname);
		}
		else
		{
			throw new Exception(sprintf('Directory %s does not exist!', $dirname));
		}
	}


	function delete_dossier($profil,$rne,$login){
		$racine="/var/www/html/balado";
		
		if($profil=="eleve")
			$rep=$racine."/voice/".$rne."/".$login;
		else
			$rep=$racine."/voice/profs/".$login;

		if(is_dir($rep)){
			recursive_rmdir($rep,true);
		}
	}	


	if($_SESSION['user_login']!="UserCron") echo "</head>";
	if($_SESSION['user_login']!="UserCron") echo "<body>";
	if($_SESSION['user_login']!="UserCron") echo "<form name='Formulaire' enctype='multipart/form-data' action='' method='post'>";

	$q = "SELECT * FROM admin_balado WHERE id=1";
	$dbprf1->query($q);
	if(!$dbprf1->next_record()) {
		AfficheLigne("ERREUR - Parametrage de synchronisation manquant");
		die();
	}

	$synchro_classe 	= $dbprf1->f("synchro_classe");
	$synchro_user 		= $dbprf1->f("synchro_user");
	$del_classe 		= $dbprf1->f("del_classe");
	$del_user 			= $dbprf1->f("del_user");

	if($synchro_user||$synchro_classe) {
		// Connexion LDAP
		$ds = ldap_connect($config['LDAPserver'], $config['LDAPport']);
		if (!$ds) {
			AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
			die();
		}
		
		$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
		if(!$r) {
			AfficheLigne("ERREUR - login impossible sur l'annuaire LDAP");
			die();
		}
	}

	// Récupérer la partie entier du rne
	$myrne=str_pad(substr($config["rneetab"],0,8),8,0,STR_PAD_LEFT);
	$rneinteger=substr($myrne,0,-1);
	
//==CREATION CLASSES===================================================================================================================================
	if($synchro_classe) {
		AfficheLigne("");
		AfficheTitre("SYNCHRONISATION CLASSES");
				
		$res = ldap_search($ds,$config['LDAPracine'],"type=Classe");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			$gidNumber 	= ldap_get_values($ds,$entryID,'gidNumber');
			$cn			= ldap_get_values($ds,$entryID,'cn');
			$niveau		= ldap_get_values($ds,$entryID,'niveau');
			@$memberUid	= ldap_get_values($ds,$entryID,'memberUid');
			
			$dbbal1->query("SELECT * FROM sconet_classes WHERE classe='".$cn[0]."' AND rne='".$myrne."'");
			if(!$dbbal1->next_record()) {
				AfficheLigne("Création classe = ".$cn[0]);
				$q="INSERT INTO sconet_classes (classe,rne) VALUES('".$cn[0]."','".$myrne."')";
				$dbbal1->query($q);
			}
			else {
				AfficheLigne("Classe existante = ".$dbbal1->f('classe'));
			}
		}
				
//==SUPPRESSION CLASSE=============================================================================================================================
		if($del_classe) {
			AfficheLigne("");
			AfficheLigne("");
			AfficheTitre("SUPPRESSION CLASSES OBSOLETES");
			
			$dbbal1->query("SELECT * FROM sconet_classes");
			while($dbbal1->next_record()) {		
				$res = ldap_search($ds,$config['LDAPracine'],"(&(type=Classe)(cn=".$dbbal1->f("classe")."))");
				if(!ldap_first_entry($ds,$res)) {
					AfficheLigne("Suppression Classe = ".$dbbal1->f("classe"));
					$dbbal2->query("DELETE FROM sconet_classes WHERE classe='".$dbbal1->f("classe")."'");
					$dbbal2->query("DELETE FROM sconet_classes WHERE classe='".$dbbal1->f("classe")."'");
				}
			}	
		}
	}


	
//==CREATION UTILISATEUR===============================================================================================================================
	if($synchro_user) {
		AfficheLigne("");
		AfficheLigne("");		
		AfficheTitre("SYNCHRONISATION UTILISATEUR");
		
        // Purge des utilisateurs en doublon
		do {
		    $fgdoublon=false;
		    $dbbal1->query("SELECT * FROM sconet");
		    while($dbbal1->next_record()) {
		        
		        // On regarde si l'utilisateur sconet a bien une correspondance dans la table eleve avec son login
		        // Si c'est pas le cas c'est qu'un eleves à pris son id
		        $dbbal2->query("SELECT * FROM eleves WHERE id_sconet=".$dbbal1->f("id")." AND login='".$dbbal1->f("login")."'");
		        if(!$dbbal2->next_record()) {
		            AfficheLigne("Purge Doublon >> ".$dbbal1->f("login"));
		            $fgdoublon=true;
				    $dbbal2->query("DELETE FROM sconet WHERE login='".$dbbal1->f("login")."'");
				    $dbbal2->query("SELECT id FROM eleves WHERE login='".$dbbal1->f("login")."'");
				    if($dbbal2->next_record()) {
					    delete_dossier("eleve",$myrne,$dbbal2->f("login"));
					    $dbbal3->query("DELETE from eleves WHERE id='".$dbbal2->f("id")."'");
					    $dbbal3->query("DELETE from eleves_groupes WHERE id_eleve='".$dbbal2->f("id")."'");
				    }		        
		        }
		        
		        // On regarde si l'utilisateur à une correspondance d'eleve mais avec un login différent
		        $dbbal2->query("SELECT * FROM eleves WHERE id_sconet=".$dbbal1->f("id")." AND login!='".$dbbal1->f("login")."'");
		        if($dbbal2->next_record()) {
		            AfficheLigne("Purge Doublon >> ".$dbbal1->f("login"));
		            $fgdoublon=true;
		            
				    $dbbal2->query("SELECT id FROM eleves WHERE id_sconet=".$dbbal1->f("id")." AND login='".$dbbal2->f("login")."'");
				    if($dbbal2->next_record()) {
					    delete_dossier("eleve",$myrne,$dbbal2->f("login"));
					    $dbbal3->query("DELETE from eleves WHERE id='".$dbbal2->f("id")."'");
					    $dbbal3->query("DELETE from eleves_groupes WHERE id_eleve='".$dbbal2->f("id")."'");
				    }		        
		        }
		    }
        } while($fgdoublon==true);


		// Lecture de l'annuaire
		$res = ldap_search($ds,$config['LDAPracine'],"(&(uid=*)(objectclass=inetOrgPerson)(!(description=Computer)))");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			
			$uid			= ldap_get_values($ds,$entryID,'uid');
			$cn				= ldap_get_values($ds,$entryID,'cn');
			$nom			= ldap_get_values($ds,$entryID,'sn');
			$prenom			= ldap_get_values($ds,$entryID,'givenName');
			
			@$civilite		= ldap_get_values($ds,$entryID,'personalTitle');
			@$sexe			= ldap_get_values($ds,$entryID,'ENTPersonSexe');
			@$mail			= ldap_get_values($ds,$entryID,'mail');
			@$profil		= ldap_get_values($ds,$entryID,'ENTPersonProfils');
			@$type   		= ldap_get_values($ds,$entryID,'type');
			@$intid			= ldap_get_values($ds,$entryID,'intid');
			@$naissance		= ldap_get_values($ds,$entryID,'dateNaissance');
			@$classe		= ldap_get_values($ds,$entryID,'Divcod');
				
			if($sexe[0]==0) $mysexe="M"; else $mysexe="F";
			$mynaissance=substr($naissance[0],0,4)."-".substr($naissance[0],4,2)."-".substr($naissance[0],6,2);
		
			switch ($profil[0]) {
				case "eleve" :
					$myid = date("Ymdhis").rand(0,400);
					
					// On s'assure que cette ID n'est pas déjà utilisé par un autre éléve
                    $dbbal1->query("SELECT * FROM eleves WHERE id='$myid' AND login!='$uid[0]'");
                    while($dbbal1->next_record()) {
                        $myid = date("Ymdhis").rand(0,400);
                    }
                    
					$dbbal1->query("SELECT * FROM eleves WHERE login='$uid[0]'");
					if(!$dbbal1->next_record()) {
						$q="INSERT INTO eleves (id_sconet,id_cas,login,nom,prenom,naissance,rne) VALUES ('$myid','$uid[0]','$uid[0]','".addslashes($nom[0])."','".addslashes($prenom[0])."','$mynaissance','".$myrne."')";
						$dbbal1->query($q);									
					}
				
					$dbbal1->query("SELECT * FROM sconet WHERE login='$uid[0]'");
					if($dbbal1->next_record()) {
						AfficheLigne("$uid[0] >> $profil[0] >> Mise à jour du profil");
						if($dbbal1->f("nom")!=$nom[0]||$dbbal1->f("prenom")!=$prenom[0]||$dbbal1->f("naissance")!=$mynaissance||$dbbal1->f("sexe")!=$mysexe||$dbbal1->f("classe")!=$classe[0]||$dbbal1->f("rne")!=$myrne) {
							$q="UPDATE sconet SET nom='".addslashes($nom[0])."', prenom='".addslashes($prenom[0])."',login='$uid[0]',naissance='$mynaissance',sexe='$mysexe',classe='$classe[0]',rne='".$myrne."' WHERE login='$uid[0]'";
							$dbbal2->query($q);
							
							$q="UPDATE eleves SET nom='".addslashes($nom[0])."', prenom='".addslashes($prenom[0])."',naissance='$mynaissance',rne='".$myrne."' WHERE login='$uid[0]'";
							$dbbal2->query($q);
						}
					}
					else {
						AfficheLigne("$uid[0] >> $profil[0] >> Création de l'utilisateur >> $myid");
						$q="INSERT INTO sconet (id,nom,prenom,login,naissance,sexe,classe,rne,id_cas,id_sconet,actif) VALUES ('$myid','".addslashes($nom[0])."','".addslashes($prenom[0])."','$uid[0]','$mynaissance','$mysexe','$classe[0]','".$myrne."','$uid[0]','$myid',1)";
						$dbbal1->query($q);									
					}
								
					// Mise à jour de la classe de l'élève
					$dbbal2->query("SELECT id FROM classes WHERE classe='".$classe[0]."'");
					if($dbbal2->next_record()) {
						$q="UPDATE eleves SET id_classe='".$dbbal2->f("id")."' WHERE login='$uid[0]'";
						$dbbal3->query($q);
					}					
				break;
				
				case "enseignant" :
					$myid=$uid[0].$rneinteger;
					
					$dbbal1->query("SELECT * FROM profs_reserve WHERE id='$myid'");
					if($dbbal1->next_record()) {
						AfficheLigne("$uid[0] >> $profil[0] >> Mise à jour du profil");
						if($dbbal1->f("nom")!=$nom[0]||$dbbal1->f("prenom")!=$prenom[0]||$dbbal1->f("rne")!=$myrne) {
							$q="UPDATE profs_reserve SET nom='$nom[0]', prenom='$prenom[0]',rne='".$myrne."' WHERE id='".$myid."'";
							$dbbal2->query($q);
							
							$q="UPDATE profs SET nom='$nom[0]', prenom='$prenom[0]' WHERE id='".$dbbal1->f("id_prof")."'";
							$dbbal2->query($q);
						}
					}
					else {
						AfficheLigne("$uid[0] >> $profil[0] >> Création du profil");
						$q="INSERT INTO profs_reserve (id,nom,prenom,rne,actif,id_prof) VALUES ('$myid','".addslashes($nom[0])."','".addslashes($prenom[0])."','".$myrne."',1,0)";
						$dbbal1->query($q);									
					}
					
					// Cas du second admin on va l'inscrire directement en gestionnaire de balado
					if ( isset($config["uid_addadmin"]) && $config["uid_addadmin"]!="" && ($uid[0] == $config["uid_addadmin"]) )
					{
						AfficheLigne("$uid[0] >> $profil[0] >> Mise à jour du profil en tant que 2ème administrateur");
						
						// Le prof existe déjà ?
						$dbbal2->query("SELECT * FROM affectation WHERE id_cas='" . $uid[0] . "'");
						
						// Si oui : mise à jour
						if($dbbal2->next_record())
						{
							AfficheLigne("$uid[0] >> $profil[0] >> Mise a jour 2ème administrateur dans les tables des profs");
							$dbbal3->query("UPDATE profs SET nom='$nom[0]', prenom='$prenom[0]', gest='1' WHERE id='".$dbbal2->f("id_prof")."'");
							$dbbal3->query("UPDATE profs_reserve SET `id_prof`='".$dbbal2->f("id_prof")."' WHERE id='".$myid."'");
						}
						// Si non creation en tant que 2nd admin
						else
						{
							AfficheLigne("$uid[0] >> $profil[0] >> Création 2ème administrateur dans les tables des profs");
							// Insérer le nouveau prof
							$dbbal3->query("INSERT INTO `profs` (`login`, `mdp`, `mel`, `nom`, `prenom`, `naissance`, `gest`, `actif`, `activation`, `mdp_perdu`) VALUES ('" . addslashes($config["uid_addadmin"]) . "', '', '', '" . addslashes($config["uid_addadmin"]) . "', '" . addslashes($config["uid_addadmin"]) . "', '1970-01-01', 1, 1, '0', '0');");  
							// Recupération de l'id du prof inséré
							$dbbal3->query("SELECT * from `profs`  WHERE `login`='" . addslashes($config["uid_addadmin"]) . "';"); 
							// Mise à jour de la table profs_reserve 
							if($dbbal3->next_record()) {
							    $dbbal2->query("UPDATE profs_reserve SET `id_prof`='".$dbbal3->f("id")."' WHERE id='".$myid."'");
							    $dbbal2->query("INSERT IGNORE INTO `affectation` (`id_prof`, `rne`, `id_cas`) VALUES ('".$dbbal3->f("id")."', '".$myrne."', '".addslashes($config["uid_addadmin"])."')");
						    }
						}
					} 
				break;
			}
		}

		
//==SUPPRESSION UTILISATEUR============================================================================================================================
		if($del_user) {
			AfficheLigne("");
			AfficheLigne("");
			AfficheTitre("SUPPRESSION DES UTILISATEURS OBSOLETES");
			

			// Suppression Eleve
			$dbbal1->query("SELECT * FROM sconet");
			while($dbbal1->next_record()) {
				$res = ldap_search($ds,$config['LDAPracine'],"uid=".$dbbal1->f("login"));
				if(!ldap_first_entry($ds,$res)) {
					AfficheLigne("Elève à supprimer = ".$dbbal1->f("login"));
					$dbbal2->query("DELETE FROM sconet WHERE login='".$dbbal1->f("login")."'");
					
					$dbbal2->query("SELECT id, login FROM eleves WHERE id_sconet='".$dbbal1->f("id")."'");
					if($dbbal2->next_record()) {
						delete_dossier("eleve",$myrne,$dbbal2->f("login"));
						
						$dbbal3->query("DELETE from eleves WHERE id='".$dbbal2->f("id")."'");
						$dbbal3->query("DELETE from eleves_groupes WHERE id_eleve='".$dbbal2->f("id")."'");
					}
				}
			}
			
			
			// Suppression Professeur
			$dbbal1->query("SELECT * FROM profs_reserve");
			while($dbbal1->next_record()) {
				$res = ldap_search($ds,$config['LDAPracine'],"uid=".substr($dbbal1->f("id"),0,-7));
				if(!ldap_first_entry($ds,$res)) {
					AfficheLigne("Professeur à supprimer = ".substr($dbbal1->f("id"),0,-7));
					
					// Suppression des fichiers physiquement
					$dbbal2->query("SELECT login FROM profs WHERE id=".$dbbal1->f("id_prof"));
					if($dbbal2->next_record()) {
						delete_dossier("prof",$myrne,$dbbal2->f("login"));
					}

					// Suppression du lien des élèves avec les groupes du prof
					$dbbal2->query("SELECT id_groupe FROM profs_groupes, eleves_groupes WHERE id_groupe=id and id_prof=".$dbbal1->f("id_prof"));
					while($dbbal2->next_record()) {
						$dbbal3->query("DELETE FROM eleves_groupes WHERE id_groupe=".$dbbal2->f("id_groupe"));
					}
										
					// Suppression des tables directement lié au professeur
					$dbbal2->query("DELETE FROM profs_reserve WHERE id='".$dbbal1->f("id")."'");
					$dbbal2->query("DELETE FROM affectation WHERE id_prof=".$dbbal1->f("id_prof"));
					$dbbal2->query("DELETE FROM profs WHERE id=".$dbbal1->f("id_prof"));
					$dbbal2->query("DELETE FROM partages WHERE id_prof=".$dbbal1->f("id_prof"));
					$dbbal2->query("DELETE FROM podcast_eleves WHERE id_prof=".$dbbal1->f("id_prof"));
					$dbbal2->query("DELETE FROM preferences WHERE id=".$dbbal1->f("id_prof"));
					$dbbal2->query("DELETE FROM profs_groupes WHERE id_prof=".$dbbal1->f("id_prof"));
					$dbbal2->query("DELETE FROM profs_classes WHERE id_prof=".$dbbal1->f("id_prof"));					
				}
			}			
		}
	}
	



	if($_SESSION['user_login']!="UserCron") echo "</form>";
	if($_SESSION['user_login']!="UserCron") echo "</body>";
	if($_SESSION['user_login']!="UserCron") echo "</html>";
?>
