<?
	
	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		parse_str($argv[2], $param);
		define('CLI_SCRIPT', true);
	}
	
	$PATH="../";
	include_once($PATH."include/include.php");
	include_once($PATH."include/admin.php");															/* Page Admin		*/
	

	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");		/* Entete HTML		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");	/* Entete HTML		*/


	$dbprf1=new ps_db;
	$dbmoo1=new ps_db;
	$dbmoo2=new ps_db;
	$dbmoo3=new ps_db;

	$dbmoo1->dbname("moodle");
	$dbmoo2->dbname("moodle");
	$dbmoo3->dbname("moodle");

	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}	

    function recursiveDelete($str,$niv){
        if(is_file($str)){
            return @unlink($str);
        }
        elseif(is_dir($str)){
            $scan = glob(rtrim($str,'/').'/*');
            foreach($scan as $index=>$path){
                recursiveDelete($path,1);
            }
            if($niv>0) return @rmdir($str);
        }
    }	

	if($_SESSION['user_login']!="UserCron") echo "</head>";
	if($_SESSION['user_login']!="UserCron") echo "<body>";
	if($_SESSION['user_login']!="UserCron") echo "<form name='Formulaire' enctype='multipart/form-data' action='' method='post'>";


	$nomoodlecookie = true; // cookie not needed

	require_once('../../moodle/config.php'); // global moodle config file.

	require_once($CFG->dirroot.'/course/lib.php');
	require_once($CFG->dirroot.'/lib/blocklib.php');
	require_once($CFG->dirroot.'/mod/resource/lib.php');
	require_once($CFG->dirroot.'/mod/forum/lib.php');
	require_once($CFG->dirroot.'/lib/moodlelib.php');
	require_once($CFG->dirroot.'/lib/accesslib.php');
	require_once($CFG->dirroot.'/cohort/lib.php');
	$cohort = new stdClass();

	if(CLI_SCRIPT) $_SESSION['user_login']="UserCron";
						
	$q = "SELECT * FROM admin_moodle WHERE id=1";
	$dbprf1->query($q);
	if(!$dbprf1->next_record()) {
		AfficheLigne("ERREUR - Parametrage de synchronisation manquant");
		die();
	}

	$synchro_classe 	= $dbprf1->f("synchro_classe");
	$synchro_user 		= $dbprf1->f("synchro_user");
	$del_classe 		= $dbprf1->f("del_classe");
	$del_user 			= $dbprf1->f("del_user");

	if($synchro_user||$synchro_classe) {
		// Connexion LDAP
		$ds = ldap_connect($config['LDAPserver'], $config['LDAPport']);
		if (!$ds) {
			AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
			die();
		}
		
		$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
		if(!$r) {
			AfficheLigne("ERREUR - login impossible sur l'annuaire LDAP");
			die();
		}
	}

	// Refresh du cache moodle
	AfficheLigne("");
	AfficheLigne("");	
	AfficheLigne("Purge du cache Moodle");	
	recursiveDelete('/home/www-data/var/www/html/moodle/cache',0);




//==CREATION GROUPE==============================================================================================================================
	if($synchro_classe) {
		AfficheLigne("");
		AfficheTitre("SYNCHRONISATION NIVEAU");		

		$res = ldap_search($ds,$config['LDAPracine'],"type=Niveau");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			$gidNumber 	= ldap_get_values($ds,$entryID,'gidNumber');
			$cn			= ldap_get_values($ds,$entryID,'cn');
			$niveau		= ldap_get_values($ds,$entryID,'niveau');
			@$memberUid	= ldap_get_values($ds,$entryID,'memberUid');
			
			
			$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name='Niveau-".$cn[0]."'");
			if(!$dbmoo1->next_record()) {
				AfficheLigne("Création Niveau = ".$cn[0]);
				$cohort->name="Niveau-".$cn[0];
				$cohort->contextid=1;
				$cohort->descriptionformat=1;
				$id=cohort_add_cohort($cohort);
			}
			else {
				AfficheLigne("Niveau existant = ".$dbmoo1->f('name'));
			}
		}


		AfficheLigne("");
		AfficheLigne("");
		AfficheTitre("SYNCHRONISATION GROUPES");
				
		$res = ldap_search($ds,$config['LDAPracine'],"type=Groupe");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			$gidNumber 	= ldap_get_values($ds,$entryID,'gidNumber');
			$cn			= ldap_get_values($ds,$entryID,'cn');
			$niveau		= ldap_get_values($ds,$entryID,'niveau');
			@$memberUid	= ldap_get_values($ds,$entryID,'memberUid');
			
			// Vérifier la présence d'au moins un eleve dans le groupe
			
			$fgeleve=false;
			$res2 = ldap_search($ds,$config['LDAPracine'],"type=Groupe");
			for ($i=0;$i<(count($memberUid)-1);$i++) {
				$res2 = ldap_search($ds,$config['LDAPracine'],"(&(uid=".$memberUid[$i].")(objectclass=inetOrgPerson)(ENTPersonProfils=eleve)(!(description=Computer)))");
				if(ldap_first_entry($ds,$res2)) $fgeleve=true;
			}
			
			if($fgeleve) {
				$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name='Groupe-".$cn[0]."'");
				if(!$dbmoo1->next_record()) {
					AfficheLigne("Création groupe = ".$cn[0]);
					$cohort->name="Groupe-".$cn[0];
					$cohort->contextid=1;
					$cohort->descriptionformat=1;
					$id=cohort_add_cohort($cohort);
				}
				else {
					AfficheLigne("Groupe existant = ".$dbmoo1->f('name'));
				}				
			}
		}

		
		AfficheLigne("");
		AfficheLigne("");
		AfficheTitre("SYNCHRONISATION CLASSES");
				
		$res = ldap_search($ds,$config['LDAPracine'],"type=Classe");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			$gidNumber 	= ldap_get_values($ds,$entryID,'gidNumber');
			$cn			= ldap_get_values($ds,$entryID,'cn');
			$niveau		= ldap_get_values($ds,$entryID,'niveau');
			@$memberUid	= ldap_get_values($ds,$entryID,'memberUid');
			
			
			$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name='Classe-".$cn[0]."'");
			if(!$dbmoo1->next_record()) {
				AfficheLigne("Création classe = ".$cn[0]);
				$cohort->name="Classe-".$cn[0];
				$cohort->contextid=1;
				$cohort->descriptionformat=1;
				$id=cohort_add_cohort($cohort);
			}
			else {
				AfficheLigne("Classe existante = ".$dbmoo1->f('name'));
			}
		}
				
//==SUPPRESSION GROUPE========================================================================================================================
		if($del_classe) {
			AfficheLigne("");
			AfficheLigne("");
			AfficheTitre("SUPPRESSION NIVEAUX OBSOLETES");
			
			$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name LIKE('Niveau-%')");
			while($dbmoo1->next_record()) {		
				$res = ldap_search($ds,$config['LDAPracine'],"(&(type=Niveau)(cn=".str_replace("Niveau-","",$dbmoo1->f("name"))."))");
				if(!ldap_first_entry($ds,$res)) {
					AfficheLigne("Suppression Niveau = ".$dbmoo1->f("name"));

					$cohort->id=$dbmoo1->f("id");
					cohort_delete_cohort($cohort);
				}
			}


			AfficheLigne("");
			AfficheLigne("");
			AfficheTitre("SUPPRESSION GROUPES OBSOLETES");
			
			$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name LIKE('Groupe-%')");
			while($dbmoo1->next_record()) {		
				$res = ldap_search($ds,$config['LDAPracine'],"(&(type=Groupe)(cn=".str_replace("Groupe-","",$dbmoo1->f("name"))."))");
				if(!$entryID=ldap_first_entry($ds,$res)) {
					AfficheLigne("Suppression Groupe1 = ".$dbmoo1->f("name"));
					$cohort->id=$dbmoo1->f("id");
					cohort_delete_cohort($cohort);
				}
				else {
					// Vérifier qu'il y a au moins un élève dans le groupe
					@$memberUid	= ldap_get_values($ds,$entryID,'memberUid');
					$fgeleve=false;
					for ($i=0;$i<(count($memberUid)-1);$i++) {
						$res2 = ldap_search($ds,$config['LDAPracine'],"(&(uid=".$memberUid[$i].")(objectclass=inetOrgPerson)(ENTPersonProfils=eleve)(!(description=Computer)))");
						if(ldap_first_entry($ds,$res2)) $fgeleve=true;
					}
					
					if(!$fgeleve) {
						AfficheLigne("Suppression Groupe2= ".$dbmoo1->f("name"));
						$cohort->id=$dbmoo1->f("id");
						cohort_delete_cohort($cohort);
					}
				}
			}
			
									
			
			AfficheLigne("");
			AfficheLigne("");
			AfficheTitre("SUPPRESSION CLASSES OBSOLETES");
			
			$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name LIKE('Classe-%')");
			while($dbmoo1->next_record()) {		
				$res = ldap_search($ds,$config['LDAPracine'],"(&(type=Classe)(cn=".str_replace("Classe-","",$dbmoo1->f("name"))."))");
				if(!ldap_first_entry($ds,$res)) {
					AfficheLigne("Suppression Classe = ".$dbmoo1->f("name"));

					$cohort->id=$dbmoo1->f("id");
					cohort_delete_cohort($cohort);
				}
			}
		}
	}
	
//==CREATION UTILISATEUR===============================================================================================================================
	if($synchro_user) {
		AfficheLigne("");
		AfficheLigne("");		
		AfficheTitre("SYNCHRONISATION UTILISATEUR");

		if (!is_enabled_auth('cas')) {
			echo "Plugin not enabled!";
			die;
		}

		// on force les nologin en CAS pour qu'il puisse etre supprimé proprement
		$dbmoo1->query("UPDATE mdl_user SET auth='cas' WHERE auth='nologin'");
		
		
		// Suppression des utilisateurs obsolètes hors script moodle
		$dbdel=0;
		$dbmoo1->query("SELECT * FROM mdl_user WHERE username!='guest' AND deleted=0");
		
		while($dbmoo1->next_record()) {		
			
            $res = ldap_search($ds,$config['LDAPracine'],"(&(objectclass=inetOrgPerson)(!(description=Computer))(uid=".$dbmoo1->f("username")."))");
            if(!ldap_first_entry($ds,$res)) {
                $dbdel=$dbdel+1;
                if($dbdel>15) {
                    $dbdel=0;
                    $dbmoo1->query("DROP TABLE tmp_extuser");
                }

                AfficheLigne("Suppression Utilisateur = ".$dbmoo1->f("username"));
                $user->id=$dbmoo1->f("id");
                $user->username=$dbmoo1->f("username");
                delete_user($user);
            }
		}
		
		
		// lancer la synchronisation
		$casauth = get_auth_plugin('cas');
		$casauth->sync_users(1000, true);
		AfficheLigne("");
		AfficheLigne("");
	}

//==AFFECTER PERMISSION CREATEUR DE COURS AUX PROFESSEURS==============================================================================================
	if($synchro_user) {
		AfficheLigne("");
		AfficheLigne("");		
		AfficheTitre("AFFECTER PERMISSION CREATEUR DE COURS AUX PROFESSEURS");
		
		$res = ldap_search($ds,$config['LDAPracine'],"(&(uid=*)(objectclass=inetOrgPerson)(|(ENTPersonProfils=enseignant)(ENTPersonProfils=administratif))(!(description=Computer)))");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			$uid			= ldap_get_values($ds,$entryID,'uid');
			
			$dbmoo1->query("SELECT * FROM mdl_user WHERE username='".$uid[0]."'");
			if($dbmoo1->next_record()) {
												
				AfficheLigne("Professeur = ".$uid[0]);
				
				if ($roles = get_archetype_roles('coursecreator')) {
					$creatorrole = array_shift($roles);
					$systemcontext = context_system::instance();

					role_assign($creatorrole->id, $dbmoo1->f("id"), $systemcontext->id);
				}
			}
			
		}		

		// Ajouter les permissions sur les cohortes nécessaires au createur de cours
		if ($roles = get_archetype_roles('coursecreator')) {
			$creatorrole = array_shift($roles);
			$systemcontext = context_system::instance();
			
			assign_capability('moodle/cohort:view', CAP_ALLOW, $creatorrole->id, $systemcontext->id, true);
			assign_capability('enrol/cohort:config', CAP_ALLOW, $creatorrole->id, $systemcontext->id, true);
		}		
	}
		
//==AFFECTATION UTILISATEUR CLASSE=====================================================================================================================
	if($synchro_classe&&$synchro_user) {
		AfficheLigne("");
		AfficheLigne("");		
		AfficheTitre("RATTACHEMENT UTILISATEUR <> NIVEAU");		

		$res = ldap_search($ds,$config['LDAPracine'],"type=Niveau");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			$gidNumber 	= ldap_get_values($ds,$entryID,'gidNumber');
			$cn			= ldap_get_values($ds,$entryID,'cn');
			$niveau		= ldap_get_values($ds,$entryID,'niveau');
			@$memberUid	= ldap_get_values($ds,$entryID,'memberUid');
							
			$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name='Niveau-".$cn[0]."'");
			if($dbmoo1->next_record()) {
				$idniveau=$dbmoo1->f('id');
				AfficheLigne("NIVEAU = ".$cn[0]);
				
				// Rattachement des élèves au niveau
				for ($i=0;$i<(count($memberUid)-1);$i++) {
					$dbmoo1->query("SELECT * FROM mdl_user WHERE username='".$memberUid[$i]."'");
					if($dbmoo1->next_record()) {
						$ideleve=$dbmoo1->f('id');
						$lbeleve=$dbmoo1->f('username');

						$dbmoo1->query("SELECT * FROM mdl_cohort_members WHERE userid=$ideleve AND cohortid=$idniveau");
						if(!$dbmoo1->next_record()) {
							AfficheLigne("Création Rattachement élève au niveau = ".$lbeleve);
							cohort_add_member($idniveau,$ideleve);
						}
						else {
							AfficheLigne("Rattachement élève au niveau existant = ".$lbeleve);
						}
					}
				}
				AfficheLigne("");
			}		
		}		


		AfficheLigne("");
		AfficheLigne("");		
		AfficheTitre("RATTACHEMENT UTILISATEUR <> GROUPE");		

		$res = ldap_search($ds,$config['LDAPracine'],"type=Groupe");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			$gidNumber 	= ldap_get_values($ds,$entryID,'gidNumber');
			$cn			= ldap_get_values($ds,$entryID,'cn');
			$niveau		= ldap_get_values($ds,$entryID,'niveau');
			@$memberUid	= ldap_get_values($ds,$entryID,'memberUid');
							
			$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name='Groupe-".$cn[0]."'");
			if($dbmoo1->next_record()) {
				$idgroupe=$dbmoo1->f('id');
				AfficheLigne("GROUPE = ".$cn[0]);
				
				// Rattachement des élèves à la classe
				for ($i=0;$i<(count($memberUid)-1);$i++) {
					// Rattacher le membre uniquement si c'est un eleve
					$res2 = ldap_search($ds,$config['LDAPracine'],"(&(uid=".$memberUid[$i].")(objectclass=inetOrgPerson)(ENTPersonProfils=eleve)(!(description=Computer)))");
					if(ldap_first_entry($ds,$res2)) {
						$dbmoo1->query("SELECT * FROM mdl_user WHERE username='".$memberUid[$i]."'");
						if($dbmoo1->next_record()) {
							$ideleve=$dbmoo1->f('id');
							$lbeleve=$dbmoo1->f('username');

							$dbmoo1->query("SELECT * FROM mdl_cohort_members WHERE userid=$ideleve AND cohortid=$idgroupe");
							if(!$dbmoo1->next_record()) {
								AfficheLigne("Création Rattachement élève au groupe = ".$lbeleve);
								cohort_add_member($idgroupe,$ideleve);
							}
							else {
								AfficheLigne("Rattachement élève au groupe existant = ".$lbeleve);
							}
						}
					}
				}
				AfficheLigne("");
			}		
		}
				
		
		AfficheLigne("");
		AfficheLigne("");		
		AfficheTitre("RATTACHEMENT UTILISATEUR <> CLASSE");		

		$res = ldap_search($ds,$config['LDAPracine'],"type=Classe");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{
			$gidNumber 	= ldap_get_values($ds,$entryID,'gidNumber');
			$cn			= ldap_get_values($ds,$entryID,'cn');
			$niveau		= ldap_get_values($ds,$entryID,'niveau');
			@$memberUid	= ldap_get_values($ds,$entryID,'memberUid');
							
			$dbmoo1->query("SELECT * FROM mdl_cohort WHERE name='Classe-".$cn[0]."'");
			if($dbmoo1->next_record()) {
				$idclasse=$dbmoo1->f('id');
				AfficheLigne("CLASSE = ".$cn[0]);
				
				// Rattachement des élèves à la classe
				for ($i=0;$i<(count($memberUid)-1);$i++) {
					$dbmoo1->query("SELECT * FROM mdl_user WHERE username='".$memberUid[$i]."'");
					if($dbmoo1->next_record()) {
						$ideleve=$dbmoo1->f('id');
						$lbeleve=$dbmoo1->f('username');

						$dbmoo1->query("SELECT * FROM mdl_cohort_members WHERE userid=$ideleve AND cohortid=$idclasse");
						if(!$dbmoo1->next_record()) {
							AfficheLigne("Création Rattachement élève à la classe = ".$lbeleve);
							cohort_add_member($idclasse,$ideleve);
						}
						else {
							AfficheLigne("Rattachement élève à la classe existant = ".$lbeleve);
						}
					}
				}
				AfficheLigne("");
			}		
		}
	
		if($del_classe&&$del_user) {
			AfficheLigne("");
			AfficheLigne("");		
			AfficheTitre("DETTACHEMENT UTILISATEUR <> NIVEAU");		
			
			$dbmoo1->query("SELECT mdl_cohort.id idcohort, mdl_cohort.name, mdl_user.id iduser, mdl_user.username
							FROM mdl_cohort, mdl_cohort_members, mdl_user
							WHERE  mdl_cohort.name LIKE('Niveau-%')
							AND mdl_cohort_members.cohortid=mdl_cohort.id
							AND mdl_cohort_members.userid=mdl_user.id");
			while($dbmoo1->next_record()) {
				$res = ldap_search($ds,$config['LDAPracine'],"(&(type=Niveau)(cn=".str_replace("Niveau-","",$dbmoo1->f("name")).")(memberUid=".$dbmoo1->f("username")."))");
				if(!ldap_first_entry($ds,$res)) {
					AfficheLigne("Déttachement niveau ".$dbmoo1->f("name")." utilisateur ".$dbmoo1->f("username"));
					cohort_remove_member($dbmoo1->f("idcohort"),$dbmoo1->f("iduser"));
				}
			}
					

			AfficheLigne("");
			AfficheLigne("");		
			AfficheTitre("DETTACHEMENT UTILISATEUR <> GROUPE");		
			
			$dbmoo1->query("SELECT mdl_cohort.id idcohort, mdl_cohort.name, mdl_user.id iduser, mdl_user.username
							FROM mdl_cohort, mdl_cohort_members, mdl_user
							WHERE  mdl_cohort.name LIKE('Groupe-%')
							AND mdl_cohort_members.cohortid=mdl_cohort.id
							AND mdl_cohort_members.userid=mdl_user.id");
			while($dbmoo1->next_record()) {
				$res = ldap_search($ds,$config['LDAPracine'],"(&(type=Groupe)(cn=".str_replace("Groupe-","",$dbmoo1->f("name")).")(memberUid=".$dbmoo1->f("username")."))");
				if(!ldap_first_entry($ds,$res)) {
					AfficheLigne("Déttachement groupe ".$dbmoo1->f("name")." utilisateur ".$dbmoo1->f("username"));
					cohort_remove_member($dbmoo1->f("idcohort"),$dbmoo1->f("iduser"));
				}
				else {
					// Vérifier que le membre est toujours un eleve
					$res2 = ldap_search($ds,$config['LDAPracine'],"(&(uid=".$dbmoo1->f("username").")(objectclass=inetOrgPerson)(ENTPersonProfils=eleve)(!(description=Computer)))");
					if(!ldap_first_entry($ds,$res2)) {
						AfficheLigne("Déttachement groupe ".$dbmoo1->f("name")." utilisateur ".$dbmoo1->f("username"));
						cohort_remove_member($dbmoo1->f("idcohort"),$dbmoo1->f("iduser"));					
					}
				}
			}
			
			AfficheLigne("");
			AfficheLigne("");		
			AfficheTitre("DETTACHEMENT UTILISATEUR <> CLASSE");		
			
			$dbmoo1->query("SELECT mdl_cohort.id idcohort, mdl_cohort.name, mdl_user.id iduser, mdl_user.username
							FROM mdl_cohort, mdl_cohort_members, mdl_user
							WHERE  mdl_cohort.name LIKE('Classe-%')
							AND mdl_cohort_members.cohortid=mdl_cohort.id
							AND mdl_cohort_members.userid=mdl_user.id");
			while($dbmoo1->next_record()) {
				$res = ldap_search($ds,$config['LDAPracine'],"(&(type=Classe)(cn=".str_replace("Classe-","",$dbmoo1->f("name")).")(memberUid=".$dbmoo1->f("username")."))");
				if(!ldap_first_entry($ds,$res)) {
					AfficheLigne("Déttachement classe ".$dbmoo1->f("name")." utilisateur ".$dbmoo1->f("username"));
					cohort_remove_member($dbmoo1->f("idcohort"),$dbmoo1->f("iduser"));
				}
			}
		}
	}

	// Refresh du cache moodle
	AfficheLigne("");
	AfficheLigne("");	
	AfficheLigne("Purge du cache Moodle");	
	recursiveDelete('/home/www-data/var/www/html/moodle/cache',0);
	
	
	if($_SESSION['user_login']!="UserCron") echo "</form>";
	if($_SESSION['user_login']!="UserCron") echo "</body>";
	if($_SESSION['user_login']!="UserCron") echo "</html>";
?>
