<?

	// On vérifie si le php est executé en ligne de commande
	if(!is_null($argv)) {
		parse_str($argv[2], $param);
	}

	$PATH="../";
	include_once($PATH."include/include.php");
	include_once($PATH."include/admin.php");
	include_once($PATH."include/owncloud.php");    

	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/html.php");		/* Entete HTML		*/
	if($_SESSION['user_login']!="UserCron") include_once($PATH.$config["templatedir"]."/frame.php");	/* Entete HTML		*/


	$dbprf1=new ps_db;
	$dbown1=new ps_db;
    $dbown1->dbname($config["owncloudhost"],"owncloud",$config["owncloudpwd"],"owncloud");
    	
	
//==FUNCTION===========================================================================================================================================
	function AfficheTitre($label) {
		if($_SESSION['user_login']!="UserCron") echo "<h1>$label</h1>"; else echo "\n*** ".strtoupper($label)." ***\n";
	}
	
	function AfficheLigne($label) {
		echo $label;
		if($_SESSION['user_login']!="UserCron") echo "<br>"; else echo "\n";
	}
	
	function AfficheLigneGras($label) {
		if($_SESSION['user_login']!="UserCron") echo "<strong>$label</strong><br>"; else echo ">> ".$label." \n";
	}	
	
	function AfficheLigneSouligne($label) {
		if($_SESSION['user_login']!="UserCron") echo "<em>$label</em><br>"; else echo "* ".$label." \n";
	}

	
	// Determine en fonction du profil sso le profil wordpress
	function Profil($uid, $ENTProfil) {
		global $config;
		
		if($uid=="admin"){
			$role="administrateur";
		}
		else {
			switch($ENTProfil){
				case "eleve": 
					$role="eleve";
					break;
				
				case "responsable": 
				    $role="responsable";
					break;
								
				case "administratif":
                    $role="administratif";
					break;

				case "enseignant":
					switch($uid){
						case "Visiteur":	$role=""; break;
						case "Meta_eleve":	$role="eleve";break;
						case "Meta_parent":	$role="responsable";break;
						case "Meta_prof":	$role="enseignant";break;
						case "Meta_perdir":	$role="administratif";break;
						default : 			$role="enseignant";
					}
					break;
				
				case "administrateur":
					$role="administratif";
					break;
				
				case "visiteur":
				default : 
					$role="";
					break;
			}	
		}
        if (isset($config['uid_addadmin']))
        {
            if ($uid == $config['uid_addadmin']){
                $role="administrateur";
            }
        }
		
	    return $role;	
	}



//==MAIN BLOCK=========================================================================================================================================
	
	$ds = ldap_connect ( $config['LDAPserver'], $config['LDAPport'] );
	if (!$ds) {
		AfficheLigne("Erreur : impossible de se connecter à l'annuaire LDAP");
		die();
	}
	$r=ldap_bind($ds,$config['LDAPreaderdn'],$config['LDAPreaderpw']);	
    if (!$r) {
		AfficheLigne("Erreur authentification : impossible de se connecter à l'annuaire LDAP");
		die();
    }

	$dbprf1->query("SELECT * FROM admin_owncloud WHERE id=1");
	if($dbprf1->next_record()) {
		// création/maj de tous les groupes (principaux et autres)
		AfficheLigne("");
		AfficheLigneGras("Définition des Quotas en fonction du profil de l'utilisateur");
					
		$res = ldap_search($ds,$config['LDAPracine'],"(&(uid=*)(objectclass=inetOrgPerson)(!(description=Computer)))");
		for ($entryID=ldap_first_entry($ds,$res);$entryID!=false;$entryID=ldap_next_entry($ds,$entryID))
		{					
			$uid		= ldap_get_values($ds,$entryID,'uid');
			@$mail		= ldap_get_values($ds,$entryID,'mail');
			@$ENTprofil	= ldap_get_values($ds,$entryID,'ENTPersonProfils');
			$quota      = "";
												
			switch(Profil($uid[0], $ENTprofil[0])) {	
			    case "eleve":
			        AfficheLigne("Utilisateur = ".$uid[0]." = eleve = ".$dbprf1->f("quota_eleve"));
			        $quota=$dbprf1->f("quota_eleve");
			        break;
			
			    case "enseignant":
    			    AfficheLigne("Utilisateur = ".$uid[0]." = enseigant = ".$dbprf1->f("quota_enseignant"));    
    			    $quota=$dbprf1->f("quota_enseignant");
    			    break;
                
                case "responsable":
    			    AfficheLigne("Utilisateur = ".$uid[0]." = responsable = ".$dbprf1->f("quota_responsable"));    
    			    $quota=$dbprf1->f("quota_responsable");
    			    break;

			    case "administratif":
    			    AfficheLigne("Utilisateur = ".$uid[0]." = administratif = ".$dbprf1->f("quota_administratif"));    
    			    $quota=$dbprf1->f("quota_administratif");
    			    break;

			    case "administrateur":
    			    AfficheLigne("Utilisateur = ".$uid[0]." = administrateur = ".$dbprf1->f("quota_administrateur"));    
    			    $quota=$dbprf1->f("quota_administrateur");
    			    break;
			}
			
			
			if($quota!="") {
			    $dbown1->query("INSERT IGNORE INTO oc_preferences (userid,appid,configkey,configvalue) VALUES ('".$uid[0]."','files','quota','$quota')  ON DUPLICATE KEY UPDATE configvalue='$quota'");
			}
		}
	}

?>
